
############################## NORMALLY DONT TOUCH ANYTHING BELOW ###########################

#ifeq ($(LD),)
LD = $(PREFIX)g++
#endif

CC = $(PREFIX)gcc
CXX = $(PREFIX)g++
AR = $(PREFIX)ar
AS = $(PREFIX)as
OBJCOPY = $(PREFIX)objcopy
OBJDUMP = $(PREFIX)objdump

# Implicit rules

$(OBJDIR)%.o : $(SRCDIR)%.c
	$(CC) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.cpp
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.cc
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.S
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.s
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)% :
	mkdir -p $@

%.bin: %.elf
	$(OBJCOPY) -O binary $< $@

SRC_MODULES = $(addprefix $(SRCDIR),$(MODULES))

CFLAGS += $(addprefix -I,$(SRC_MODULES))

MO = $(patsubst %.cpp,%.o, $(wildcard $(addsuffix /*.cpp, $(SRC_MODULES))))
MO += $(patsubst %.c,%.o, $(wildcard $(addsuffix /*.c, $(SRC_MODULES))))
MO += $(patsubst %.s,%.o, $(wildcard $(addsuffix /*.s, $(SRC_MODULES))))

MODULEOBJS = $(subst $(SRCDIR),,$(MO))

OBJFILES = $(addprefix $(OBJDIR),$(OBJS) $(MODULEOBJS))
OBJDIRS = $(OBJDIR) $(addprefix $(OBJDIR), $(MODULES))

all : $(OBJDIRS) $(OBJFILES) $(TARGET)$(EXT)

%.gbfs :
	gbfs $@ data/*

$(OBJDIR) :
	mkdir -p $(OBJDIR)

$(TARGET).a : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(AR) r $(TARGET).a $(OBJFILES)

$(TARGET).elf : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -o $(TARGET).elf $(OBJFILES) $(LIBS)

$(TARGET) : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) -o $(TARGET) $(OBJFILES) $(LIBS) $(LDFLAGS)

$(TARGET).bin : $(TARGET).elf
	$(OBJCOPY) -O binary $< $@


clean :
	rm -rf $(OBJFILES) $(TARGET)$(EXT)


#.PRECIOUS : %.nds %.bin %.fs.bin

$(TARGET).ds.gba : $(TARGET).nds
	dsbuild $< -o $@.tmp
	padbin 256 $@.tmp
	cat $@.tmp $(TARGET).gbfs > $(TARGET).ds.gba


$(TARGET).nds : $(TARGET).bin $(TARGET)7.bin
	ndstool  -9 $(TARGET).bin -7 $(TARGET)7.bin -c $@

toflash : $(TARGET).nds
	mount /mnt/cflash
	rm -f /mnt/cflash/kazar.*
	cp $(TARGET).nds /mnt/cflash/_boot_mp.nds
	umount /mnt/cflash



#gbfs data.gbfs data/*
#insgbfs data.gbfs $(TARGET).nds gbfs_space
