
#include "../AppHdr.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include <ctype.h>

#include <pogo/pogo.h>

#ifdef DS
#include <nds.h>
#include <gbfs.h>
#include <nds/bios.h>
#include "Sound9.h"

#endif

#include "../defines.h"
#include "../enum.h"
#include "../tags.h"

extern int use_gbacart;

extern "C"
{
	void mod_volume(int vol)
	{
		int t;

		if(use_gbacart)
			return;

#ifdef DS
		SoundSendCmd(SND_CMD_SETVOLUME, vol);
		t = pogo_clock();
		while(t+2 < pogo_clock())
			swiWaitForIRQ();
#endif
	}
}


/*
enum BRANCHES                          // you.where_are_you
{
    BRANCH_MAIN_DUNGEON,               //    0
    BRANCH_DIS,
    BRANCH_GEHENNA,
    BRANCH_VESTIBULE_OF_HELL,
    BRANCH_COCYTUS,
    BRANCH_TARTARUS,                   //    5
    BRANCH_INFERNO,                             // unimplemented
    BRANCH_THE_PIT,                    //    7  // unimplemented
    BRANCH_ORCISH_MINES = 10,          //   10
    BRANCH_HIVE,
    BRANCH_LAIR,
    BRANCH_SLIME_PITS,
    BRANCH_VAULTS,
    BRANCH_CRYPT,                      //   15
    BRANCH_HALL_OF_BLADES,
    BRANCH_HALL_OF_ZOT,
    BRANCH_ECUMENICAL_TEMPLE,
    BRANCH_SNAKE_PIT,
    BRANCH_ELVEN_HALLS,                //   20
    BRANCH_TOMB,
    BRANCH_SWAMP
};
*/

enum {MAIN, INTRO, HISCORE};


char *mod_names[32];
void *mod_ptr = NULL;

void modplay_init()
{
#ifdef DS
	SndInit9();
#endif
	memset(mod_names, 0, 32*sizeof(void*));

	mod_names[MAIN] = "elvira-maze.mod";
	mod_names[INTRO] = "faerghail.mod";
	mod_names[HISCORE] = "ultima5.mod";
	mod_names[BRANCH_MAIN_DUNGEON + 3] = "faerghail.mod";
	mod_names[BRANCH_LAIR + 3] = "elvira-catacombs.mod";
	mod_names[BRANCH_ECUMENICAL_TEMPLE + 3] = "ultima5.mod";
	mod_names[BRANCH_TOMB + 3] = "castlemaster.mod";
	mod_names[BRANCH_VAULTS + 3] = "castlemaster.mod";
	mod_names[BRANCH_CRYPT + 3] = "castlemaster.mod";
	mod_names[BRANCH_SNAKE_PIT + 3] =  "bloodmoney.mod";
	mod_names[BRANCH_SLIME_PITS + 3] =  "bloodmoney.mod";
	mod_names[BRANCH_SWAMP + 3] = "bloodmoney.mod";
	mod_names[BRANCH_HIVE + 3] =  "bloodmoney.mod";
	mod_names[BRANCH_ORCISH_MINES + 3] = "elvira-upstairs.mod";
	mod_names[BRANCH_ELVEN_HALLS + 3] = "elvira-upstairs.mod";
}

char *current_name = "";

void modplay_playsong(int n)
{
	char *name = mod_names[n];
	if(!name)
		name = mod_names[0];

	if(!name)
		return;

	if(strcmp(name, current_name) == 0)
		return;

	current_name = name;

#ifdef DS
	SndStopMOD();
#endif

	if(name)
	{
		POGOFILE *fp = pogo_smartopen(name, "rb");
		if(fp)
		{
			pogo_fseek(fp, 0, SEEK_END);
			int len = pogo_ftell(fp);
			pogo_fseek(fp, 0, SEEK_SET);
			mod_ptr = realloc(mod_ptr, len);
			len = pogo_fread(mod_ptr, 1, len*2, fp);
			pogo_fclose(fp);
#ifdef DS
			SndPlayMOD(mod_ptr);
#endif
		}
	}
}
