
############################## NORMALLY DONT TOUCH ANYTHING BELOW ###########################

LD = $(PREFIX)g++
CC = $(PREFIX)gcc
CXX = $(PREFIX)g++
AR = $(PREFIX)ar
AS = $(PREFIX)as
OBJCOPY = $(PREFIX)objcopy
OBJDUMP = $(PREFIX)objdump

# Implicit rules

$(OBJDIR)%.o : $(SRCDIR)%.c
	$(CC) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.cpp
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.cc
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.S
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.s
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)% :
	mkdir -p $@

%.bin: %.elf
	$(OBJCOPY) -O binary $< $@

SRC_MODULES = $(addprefix $(SRCDIR),$(MODULES))

CFLAGS += $(addprefix -I,$(SRC_MODULES))

MO = $(patsubst %.cpp,%.o, $(wildcard $(addsuffix /*.cpp, $(SRC_MODULES))))
MO += $(patsubst %.c,%.o, $(wildcard $(addsuffix /*.c, $(SRC_MODULES))))
MO += $(patsubst %.s,%.o, $(wildcard $(addsuffix /*.s, $(SRC_MODULES))))

MODULEOBJS = $(subst $(SRCDIR),,$(MO))

OBJFILES = $(addprefix $(OBJDIR),$(OBJS) $(MODULEOBJS))
OBJDIRS = $(OBJDIR) $(addprefix $(OBJDIR), $(MODULES))

target : $(TARGETDIR) $(OBJDIRS) $(OBJFILES) $(TARGETDIR)$(TARGET)$(EXT)

%.gbfs :
	gbfs $@ data/*

$(OBJDIR) :
	mkdir -p $(OBJDIR)

$(TARGETDIR) :
	mkdir -p $(TARGETDIR)

$(TARGETDIR)$(TARGET).a : $(TARGETDIR) $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(AR) r $(TARGETDIR)$(TARGET).a $(OBJFILES)

$(TARGETDIR)$(TARGET).elf : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -o $(TARGETDIR)$(TARGET).elf $(OBJFILES) $(LIBS)

$(TARGETDIR)$(TARGET) : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) -o $(TARGETDIR)$(TARGET) $(OBJFILES) $(LIBS) $(LDFLAGS)

$(TARGETDIR)$(TARGET).bin : $(TARGETDIR)$(TARGET).elf
	$(OBJCOPY) -O binary $< $@

$(TARGETDIR)$(TARGET).so : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -Wl,-soname,$(TARGET).so -shared -o $(TARGETDIR)$(TARGET).so $(OBJFILES) $(LIBS)

$(TARGETDIR)$(TARGET).dll : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -shared -o $(TARGETDIR)$(TARGET).dll $(OBJFILES) $(LIBS)

clean :
	rm -rf $(OBJFILES) $(TARGET)$(EXT)


#.PRECIOUS : %.nds %.bin %.fs.bin

$(TARGETDIR)$(TARGET).ds.gba : $(TARGETDIR)$(TARGET).nds
	dsbuild $< -o $@.tmp
	padbin 256 $@.tmp
	cat $@.tmp $(TARGETDIR)$(TARGET).gbfs > $(TARGETDIR)$(TARGET).ds.gba


# $(TARGETDIR)$(TARGET).nds : $(TARGETDIR)$(TARGET).bin $(TARGETDIR)$(TARGET)7.bin
#	ndstool  -9 $(TARGETDIR)$(TARGET).bin -7 $(TARGETDIR)$(TARGET)7.bin -c $@

$(TARGETDIR)$(TARGET).nds : $(TARGETDIR)$(TARGET).bin
#	ndstool  -9 $(TARGETDIR)$(TARGET).bin -7 arm7.bin -c $@	
	ndstool  -9 $(TARGETDIR)$(TARGET).bin -c $@

toflash : $(TARGETDIR)$(TARGET).nds
	mount /mnt/cflash
	cp $(TARGETDIR)$(TARGET).nds /mnt/cflash/_boot_mp.nds
	umount /mnt/cflash

togbfs : $(TARGETDIR)$(TARGET).nds
	cp $(TARGETDIR)$(TARGET).nds $(TARGETDIR)$(TARGET)_temp.nds
	padbin 1024 $(TARGETDIR)$(TARGET)_temp.nds
	cat $(TARGETDIR)$(TARGET)_temp.nds $(TARGETDIR)$(TARGET).gbfs > $(TARGETDIR)$(TARGET).nds



#gbfs data.gbfs data/*
#insgbfs data.gbfs $(TARGET).nds gbfs_space

