
CC = cl.exe
LD = link.exe

REL_CFLAGS = /EHsc /O2 /Og /Oi /Ot /MD /D_WIN32 $(CFLAGS)
DEB_CFLAGS = /EHsc /Zi /MDd /D_WIN32 /Zi $(CFLAGS)

DEB_LDFLAGS = /SUBSYSTEM:WINDOWS $(LDFLAGS)
REL_LDFLAGS = /SUBSYSTEM:WINDOWS $(LDFLAGS)

DEB_OBJFILES = $(addprefix Debug/,$(OBJFILES))
REL_OBJFILES = $(addprefix Release/,$(OBJFILES))

all: Release Debug Release/$(TARGET) Debug/$(TARGET)

Release :
	"mkdir" -p Release

Debug :
	"mkdir" -p Debug

Debug/$(TARGET) : $(DEB_OBJFILES)
	$(LD) $(DEB_LDFLAGS) /OUT:Debug\$(TARGET) $(DEB_OBJFILES) $(LIBS)

Release/$(TARGET) : $(REL_OBJFILES)
	$(LD) $(REL_LDFLAGS) /OUT:Release\$(TARGET) $(REL_OBJFILES) $(LIBS)

Debug/%.obj : %.c
	$(CC) /c $(DEB_CFLAGS) $< /Fo$@

Release/%.obj : %.c
	$(CC) /c $(REL_CFLAGS) $< /Fo$@

clean :
	rm $(DEB_OBJFILES) $(REL_OBJFILES) Debug/$(TARGET) Release/$(TARGET)

rebuild: clean all
