#include <stdio.h>
#include <stdlib.h>

#include "glk.h"
#include "gi_blorb.h"  
#include "gi_dispa.h"

#include "png.h"

char *pData;

void ReadData(png_structp png_ptr, png_bytep data, png_size_t length)
{
	memcpy(data, pData, length);
	pData += length;
}


void *load_png(char *pngdata, int pnglen)
{
	png_structp png_ptr;
	png_infop info_ptr;
	png_infop end_info;
	png_uint_32 width, height;
	int bit_depth, color_type;
	png_bytep* pRowPointers = NULL;

	if(!png_check_sig(pData,8))
		return NULL;

	
	png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, (png_voidp)NULL, NULL, NULL);

	if(!png_ptr)
		return NULL;

	info_ptr = png_create_info_struct(png_ptr);
	if(!info_ptr)
	{
		png_destroy_read_struct(&png_ptr, (png_infopp)NULL,(png_infopp)NULL);
		return NULL;
	}

	end_info = png_create_info_struct(png_ptr);
	if(!end_info)
	{
		png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
		return NULL;
	}

	if(setjmp(png_ptr->jmpbuf))
	{
		png_destroy_read_struct(&png_ptr,&info_ptr,&end_info);
		if(pRowPointers)
			free(pRowPointers);
		return NULL;
	}

	pData = pngdata;
	png_set_read_fn(png_ptr, NULL, ReadData);
	
	png_set_sig_bytes(png_ptr,8);
	png_read_info(png_ptr,info_ptr);

	width = png_get_image_width(png_ptr,info_ptr);
	height = png_get_image_height(png_ptr,info_ptr);
	bit_depth = png_get_bit_depth(png_ptr,info_ptr);
	color_type = png_get_color_type(png_ptr,info_ptr);

	if (1)
	{
		int size;

		if (color_type == PNG_COLOR_TYPE_PALETTE && bit_depth <= 8)
			png_set_palette_to_rgb(png_ptr);
		if (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8)
			png_set_gray_1_2_4_to_8(png_ptr);
		if (png_get_valid(png_ptr,info_ptr,PNG_INFO_tRNS))
			png_set_tRNS_to_alpha(png_ptr);

		if (bit_depth == 16)
			png_set_strip_16(png_ptr);
		if (bit_depth < 8)
			png_set_packing(png_ptr);
		if (color_type == PNG_COLOR_TYPE_GRAY || color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
			png_set_gray_to_rgb(png_ptr);

		png_set_bgr(png_ptr);
		png_set_filler(png_ptr,0,PNG_FILLER_AFTER);

/*		pGraphic->m_pHeader = new BITMAPINFOHEADER;
		ZeroMemory(pGraphic->m_pHeader,sizeof(BITMAPINFOHEADER));
		pGraphic->m_pHeader->biSize = sizeof(BITMAPINFOHEADER);
		pGraphic->m_pHeader->biWidth = width;
		pGraphic->m_pHeader->biHeight = height*-1;
		pGraphic->m_pHeader->biPlanes = 1;
		pGraphic->m_pHeader->biBitCount = 32;
		pGraphic->m_pHeader->biCompression = BI_RGB;
*/
		size = width*height*4;
//		pGraphic->m_pPixels = new BYTE[size];

		pRowPointers = malloc(sizeof(png_bytep) * height);
//		for (int i = 0; i < (int)height; i++)
//			pRowPointers[i] = pGraphic->m_pPixels+(width*i*4);
		png_read_image(png_ptr, pRowPointers);
		png_read_end(png_ptr, end_info);
/*
		BYTE alpha;
		for (i = 0; i < size; i += 4)
		{
			alpha = pGraphic->m_pPixels[i+3];
			if (alpha != 0)
				pGraphic->m_bAlpha = true;
		}*/
	}

	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	if (pRowPointers)
		free(pRowPointers);

}