
#define IE             ((vuint32*)0x04000210)
#define IF             ((vuint32*)0x04000214)
#define IME            ((vuint16*)0x04000208)
 


#define IRQ_VBLANK     (1 << 0)
#define IRQ_HBLANK     (1 << 1)
#define IRQ_YTRIGGER   (1 << 2)
#define IRQ_TIMER0     (1 << 3)
#define IRQ_TIMER1     (1 << 4)
#define IRQ_TIMER2     (1 << 5)
#define IRQ_TIMER3     (1 << 6)
#define IRQ_NETWORK    (1 << 7)
#define IRQ_DMA0       (1 << 8)
#define IRQ_DMA1       (1 << 9)
#define IRQ_DMA2       (1 << 10)
#define IRQ_DMA3       (1 << 11)
#define IRQ_KEYS       (1 << 12)
#define IRQ_CART       (1 << 13)

#define IRQ_CARD       (1 << 19)
#define IRQ_CARD_LINE  (1 << 20)

#define Arm9IrqPointer ((uint32 *)0x00803FFC) 

#define REG8(x) ((vuchar*)(0x04000000 | x))
#define REG16(x) ((vuint16*)(0x04000000 | x))
#define REG32(x) ((vuint32*)(0x04000000 | x))

#define TM0CNT_L ((vuint16*)0x04000100)
#define TM0CNT_H ((vuint16*)0x04000102)
#define TM1CNT_L ((vuint16*)0x04000104)
#define TM1CNT_H ((vuint16*)0x04000106)

#define DISPCNT       ((vuint32*)0x04000000)
#define DISPCNT_SUB  ((vuint32*)0x04001000)

#define BG0CNT_SUB REG16(0x1008)

#define DISPSTAT REG16(0x0004)


#define POWER_CR REG16(0x0304)

#define KEYS REG16(0x130)

//#define IPC16 ((volatile uint16 *)(0x02000000))
//#define IPC32 ((volatile uint32 *)(0x02000000))
#define IPC16 ((volatile uint16 *)(0x027FF000))
#define IPC32 ((volatile uint32 *)(0x027FF000))

#define BANK_A_CR     REG8(0x240)
#define BANK_B_CR     REG8(0x241)
#define BANK_C_CR     REG8(0x242)
#define BANK_D_CR     REG8(0x243) 
#define BANK_E_CR     REG8(0x244)
#define BANK_F_CR     REG8(0x245)
#define BANK_G_CR     REG8(0x246)
#define BANK_WRAM_CR  REG8(0x247)
#define BANK_H_CR     REG8(0x248)
#define BANK_I_CR     REG8(0x249)
	


#define VRAM ((uint 16*)0x06000000)

#define POWER_LCD_TOP    (1<<0)
#define POWER_2D         (1<<1)
#define POWER_MATRIX     (1<<2)
#define POWER_3D_CORE    (1<<3)
#define POWER_LCD_BOTTOM (1<<8)
#define POWER_2D_SUB     (1<<9)
#define POWER_SWAP_LCDS  (1<<15)
#define POWER_ALL_2D     (POWER_LCD_TOP | POWER_LCD_BOTTOM | POWER_2D | POWER_2D_SUB)
#define POWER_ALL		 (POWER_ALL_2D | POWER_3D_CORE | POWER_MATRIX)
 

#define SETREG8(reg, v) (((uchar *)REGS)[reg] = v)
#define SETREG16(reg, v) (((uint16 *)REGS)[reg>>1] = v)
#define SETREG32(reg, v) (((uint32 *)REGS)[reg>>2] = v)

#define MODE_0_2D      0x10000
#define MODE_1_2D      0x10001
#define MODE_2_2D      0x10002
#define MODE_3_2D      0x10003
#define MODE_4_2D      0x10004
#define MODE_5_2D      0x10005

#define MODE_FB0    (0x00020000)
#define MODE_FB1    (0x00060000)
#define MODE_FB2	(0x000A0000)
#define MODE_FB3	(0x000E0000)
 

// main display only
#define MODE_6_2D      0x10006

#define ENABLE_3D    (1<<3)

#define DISPLAY_BG0_ACTIVE    (1 << 8)
#define DISPLAY_BG1_ACTIVE    (1 << 9)
#define DISPLAY_BG2_ACTIVE    (1 << 10)
#define DISPLAY_BG3_ACTIVE    (1 << 11)
#define DISPLAY_SPR_ACTIVE    (1 << 12)
#define DISPLAY_WIN0_ON       (1 << 13)
#define DISPLAY_WIN1_ON       (1 << 14)
#define DISPLAY_SPR_WIN_ON    (1 << 15)
 
#define EXMEMCNT ((vuint16*)0x04000204)

/*
 
31    OBJ EXTENDED PALETTE
30    BG EXTENDED PALETTE
27:29 BG SCREEN OFFSET
24:26 BG CHAR OFFSET
18:19 VRAM BANK
	0 = BANK_A
	1 = BANK_B
	2 = BANK_C
	3 = BANK_D
17:16 DISPLAY MODE
    0 = DISPLAY OFF
	1 = GRAPHICS (USE SCREENMODE BELOW)
	2 = DIRECT FRAMEBUFFER (USE VRAM BANK ABOVE)
	3 = MMEM

2:0 SCREENMODE

*/
