#ifndef POGOSTDCORE_H
#define POGOSTDCORE_H

/*

These are the routines required by libpogo to exist. They can either be provided
by the normal clibrary or by libcore.a which is the clib replacement part of pogo.
Applications only include this file in the latter case.

This file is also included by libpogo when compiling.

*/

#include "pogo/types.h"


#ifdef __cplusplus
extern "C" {
#endif

#ifdef _WIN32
#include <stdarg.h>
#else

#ifndef va_start
// Map stdargs to gcclibs implementation
typedef __builtin_va_list va_list;
#define va_start(v,l) __builtin_stdarg_start((v),l)
#define va_end __builtin_va_end
#define va_arg __builtin_va_arg
#endif

#endif

#define POGO_NULL 0
#define POGO_EOF (-1)


//#ifdef LIBPOGO

/*
typedef unsigned long int pgsize_t;
//typedef unsigned int pgsize_t;

// libpogo relies on these functions to be present at link time

void *memset(void *dest, int v, pgsize_t l);
void *memmove(void *dst, const void *src, pgsize_t l);
void *memcpy(void *dst, const void *src, pgsize_t l);
int strcmp(const char *s1, const char *s2);
int strncmp(const char *s1, const char *s2, pgsize_t n);
pgsize_t strlen(const char *s);
char *strcpy(char *dst, const char *src);
char *strncpy(char *dst, const char *src, pgsize_t n);
int memcmp(const void *s1, const void *s2, pgsize_t n);

void *malloc(pgsize_t x);
void *realloc(void *p, pgsize_t x);
void free(void *x);
void *calloc(pgsize_t x, pgsize_t y);
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#endif


#ifdef __cplusplus
}
#endif

#endif


