
#undef XY
#undef SCREENBASE
#undef SCREEN_SET
#undef SCREEN_COPY
#undef SCREEN_PIXEL
#undef SCREEN_SCROLL
#undef LINEAR_X

#if (SCREEN_ROTATION == 0)

// NORMAL (FROM TOP-LEFT)
#define XY(x,y) ((y)*POGO_SCRWIDTH+(x))
#define SCREENBASE ((Pixel*)POGO_SCRPTR)
#define SCREEN_SET screen_set_tl
#define SCREEN_COPY screen_copy_tl
#define SCREEN_PIXEL screen_pixel_tl
#define SCREEN_SCROLL screen_scroll_tl

#define LINEAR_X

#elif (SCREEN_ROTATION == 1)

// FROM TOP-RIGHT
#define XY(x,y) ((x) * POGO_SCRWIDTH - (y))
#define SCREENBASE (((Pixel*)POGO_SCRPTR)+POGO_SCRWIDTH-1-POGO_SCROFFSET)
#define SCREEN_SET screen_set_tr
#define SCREEN_COPY screen_copy_tr
#define SCREEN_PIXEL screen_pixel_tr
#define SCREEN_SCROLL screen_scroll_tr

#elif (SCREEN_ROTATION == 2)

// FROM BOTTOM-RIGHT
#define XY(x,y) (-(y)*POGO_SCRWIDTH-(x))
#define SCREENBASE (((Pixel*)POGO_SCRPTR)+POGO_SCRWIDTH*POGO_SCRHEIGHT-1-POGO_SCROFFSET)
#define SCREEN_SET screen_set_br
#define SCREEN_COPY screen_copy_br
#define SCREEN_PIXEL screen_pixel_br
#define SCREEN_SCROLL screen_scroll_br

#elif (SCREEN_ROTATION == 3)

// FROM BOTTOM-LEFT
#define XY(x,y) ((y) - (x) * POGO_SCRWIDTH)
#define SCREENBASE (((Pixel*)POGO_SCRPTR)+POGO_SCRWIDTH*(POGO_SCRHEIGHT-1))
#define SCREEN_SET screen_set_bl
#define SCREEN_COPY screen_copy_bl
#define SCREEN_PIXEL screen_pixel_bl
#define SCREEN_SCROLL screen_scroll_bl

#else

#error "SCREEN_ROTATION not defined!"

#endif


void SCREEN_COPY(int x, int y, uchar *src, int width, int height, int sw, int solid)
{
	int w;

	Pixel *dst = SCREENBASE + XY(x,y);

	int smod = (sw - width);
	int dmod = XY(-width, 1);

	while(height--)
	{
		w = width;
		if(solid)
		{
			while(w--)
#ifdef LINEAR_X
			COPY_PIXEL(dst++, src++);
#else
			{
				COPY_PIXEL(dst, src++);
				dst += XY(1,0);
			}
#endif
		}
		else
		{
			while(w--)
			{
				if(*src)//;// < *dst)
					COPY_PIXEL(dst, src);
					//*dst = colors[*src];
#ifdef LINEAR_X
				dst++;
#else
				dst += XY(1,0);
#endif
				src++;
			}
		}
		dst += dmod;
		src += smod;
	}
}


void SCREEN_SET(int x, int y, int width, int height, uint32 color)
{
	int w;
	
//#ifdef DIRECT
//	Pixel color = col;
//#else
//	Pixel color = colors[col];
//#endif
	
	Pixel *dst = SCREENBASE + XY(x,y);
	
	int dmod = XY(-width, 1);

	while(height--)
	{
		w = width;
		while(w--)
#ifdef LINEAR_X
			*dst++ = color;
#else
			{
				*dst = color;
				dst += XY(1,0);
			}
#endif
		dst += dmod;
	}
}

void SCREEN_SCROLL(int x, int y, int width, int height, int lines)
{
	Pixel *dst = SCREENBASE + XY(x,y);
	Pixel *src = SCREENBASE + XY(x,y+lines);
	
	int h = height-lines;

	int mod = XY(-width, 1);

	while(h--)
	{
		int w = width;
		while(w--)
		{
#ifdef LINEAR_X
			*dst++ = *src++;
#else
			*dst = *src;
			dst += XY(1,0);
			src += XY(1,0);
#endif
		}
		
		src += mod;
		dst += mod;
	}
	
	SCREEN_SET(x, y+height-lines, width, lines, screen_color(0));
}


#define ABS(x) (x < 0 ? -(x) : x)
// #define SWAP(x,y) {x ^= y; y ^= x; x ^= y; }

static int tmp;
#define SWAP(x,y) { tmp = x; x = y; y = tmp; }

//int col = UINT2PIXEL(0x0050FF);

//#define PLOT(x,y) { ptr[(x)+width*(y)] = col; ptr[(x)+1+width*(y)] = col;	\
//ptr[(x)+width*((y)+1)] = col; ptr[(x)+1+width*((y)+1)] = col;	}

Pixel *SCREEN_PIXEL(int x, int y)
{
	return SCREENBASE + XY(x,y);
}

/*
Pixel *SCREEN_PIXEL(int x, int y, uint32 color, int size)
{
//#ifdef DIRECT
//	Pixel color = col;
//#else
//	Pixel color = colors[col];
//#endif
	Pixel *dst = SCREENBASE + XY(x,y);
	
	if(size == 1)
	{
		*dst = color;
	}
	else
	{
		dst[0] = color;
		dst[XY(1,0)] = color;
		dst[XY(0,1)] = color;
		dst[XY(1,1)] = color;
	}
				
}
*/
