
#include <nds.h>


#define ISLEAP(y)           (!((y) % 4) && (((y) % 100) || !((y) % 400)))
#define DAY2S(dys)          ((u32)(dys) * 86400U)
#define HOURS2S(hrs)        ((u32)(hrs) * 3600U)
#define MINUTES2S(min)      ((u32)(min) * 60U)

u16 mdays[]   = { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365 };
u16 mdays_leap[] = { 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366 };

#define rtc24hours(h) ((h > 51) ? h-40 : h)

extern vuint32 frame_counter;

u32 NDSX_time()
{
	u32 year = IPC->time.rtc.year;
	u32 month = IPC->time.rtc.month;
	u32 day = IPC->time.rtc.day;
	u32 hours = IPC->time.rtc.hours;
	u32 mins = IPC->time.rtc.minutes;
	u32 secs = IPC->time.rtc.seconds;

    u32 year_shit1 = (year+30) / 4; // get number of 4-years
    u32 year_shit2 = (year+30) % 4; // rest of 4-years (1, 2, 3 are important)
    u32 years_in_sec = year_shit1 * (31536000U*3U + 31622400U);
    if(year_shit2 == 1)
        years_in_sec += 31536000U; // normal year
    else if(year_shit2 == 2)
        years_in_sec += 31536000U + 31622400U; // normal year + leap year
    else if(year_shit2 == 3)
        years_in_sec += 31536000U*2U + 31622400U; // normal year * 2 + leap year

	u32 rc = 0//years_in_sec
        + ISLEAP(year+2000U) ? DAY2S(mdays_leap[month-1]) : DAY2S(mdays[month-1])
        + DAY2S(day-1)
        + HOURS2S(rtc24hours(hours))
        + MINUTES2S(mins)
        + secs
        ;

	rc += years_in_sec;

	return rc;
}
